git-submodule.sh 17.8 KB
Newer Older
L
Lars Hjemli 已提交
1 2
#!/bin/sh
#
3
# git-submodules.sh: add, init, update or list git submodules
L
Lars Hjemli 已提交
4 5 6
#
# Copyright (c) 2007 Lars Hjemli

7
dashless=$(basename "$0" | sed -e 's/-/ /')
8
USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9
   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10
   or: $dashless [--quiet] init [--] [<path>...]
11
   or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12
   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13
   or: $dashless [--quiet] foreach [--recursive] <command>
14
   or: $dashless [--quiet] sync [--] [<path>...]"
15
OPTIONS_SPEC=
L
Lars Hjemli 已提交
16
. git-sh-setup
17
. git-parse-remote
L
Lars Hjemli 已提交
18 19
require_work_tree

20
command=
21
branch=
22
force=
23
reference=
L
Lars Hjemli 已提交
24
cached=
25 26
recursive=
init=
27
files=
28
nofetch=
29
update=
30
prefix=
L
Lars Hjemli 已提交
31

32 33 34
# Resolve relative url by appending to parent's url
resolve_relative_url ()
{
35
	remote=$(get_default_remote)
36 37
	remoteurl=$(git config "remote.$remote.url") ||
		die "remote ($remote) does not have a url defined in .git/config"
38
	url="$1"
39
	remoteurl=${remoteurl%/}
40 41 42 43 44 45 46 47 48 49 50 51 52 53
	while test -n "$url"
	do
		case "$url" in
		../*)
			url="${url#../}"
			remoteurl="${remoteurl%/*}"
			;;
		./*)
			url="${url#./}"
			;;
		*)
			break;;
		esac
	done
54
	echo "$remoteurl/${url%/}"
55 56
}

57 58 59 60 61 62
#
# Get submodule info for registered submodules
# $@ = path to limit submodule list
#
module_list()
{
63
	git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
64 65
}

66 67 68 69 70 71 72
#
# Map submodule path to submodule name
#
# $1 = path
#
module_name()
{
73
	# Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
C
Chris Ridd 已提交
74
	re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
75
	name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
76
		sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
77 78 79 80
       test -z "$name" &&
       die "No submodule mapping found in .gitmodules for path '$path'"
       echo "$name"
}
81 82 83 84

#
# Clone a submodule
#
85
# Prior to calling, cmd_update checks that a possibly existing
86
# path is not a git repository.
87
# Likewise, cmd_add checks that path does not exist at all,
88 89
# since it is the location of a new submodule.
#
90 91 92 93
module_clone()
{
	path=$1
	url=$2
94
	reference="$3"
95 96 97 98 99 100 101 102 103

	# If there already is a directory at the submodule path,
	# expect it to be empty (since that is the default checkout
	# action) and try to remove it.
	# Note: if $path is a symlink to a directory the test will
	# succeed but the rmdir will fail. We might want to fix this.
	if test -d "$path"
	then
		rmdir "$path" 2>/dev/null ||
104
		die "Directory '$path' exists, but is neither empty nor a git repository"
105 106 107 108 109
	fi

	test -e "$path" &&
	die "A file already exist at path '$path'"

110 111 112 113 114 115
	if test -n "$reference"
	then
		git-clone "$reference" -n "$url" "$path"
	else
		git-clone -n "$url" "$path"
	fi ||
116
	die "Clone of '$url' into submodule path '$path' failed"
117 118
}

119 120 121
#
# Add a new submodule to the working tree, .gitmodules and the index
#
122
# $@ = repo path
123 124 125
#
# optional branch is stored in global branch variable
#
126
cmd_add()
127
{
128 129 130 131 132 133 134 135 136
	# parse $args after "submodule ... add".
	while test $# -ne 0
	do
		case "$1" in
		-b | --branch)
			case "$2" in '') usage ;; esac
			branch=$2
			shift
			;;
137 138 139
		-f | --force)
			force=$1
			;;
140
		-q|--quiet)
141
			GIT_QUIET=1
142
			;;
143 144 145 146 147 148 149 150 151
		--reference)
			case "$2" in '') usage ;; esac
			reference="--reference=$2"
			shift
			;;
		--reference=*)
			reference="$1"
			shift
			;;
152 153 154 155 156 157 158 159 160 161 162 163 164 165
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

166 167 168
	repo=$1
	path=$2

169 170 171 172 173
	if test -z "$path"; then
		path=$(echo "$repo" |
			sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
	fi

174
	if test -z "$repo" -o -z "$path"; then
175 176 177
		usage
	fi

178 179 180 181 182 183 184 185 186 187 188 189 190 191 192
	# assure repo is absolute or relative to parent
	case "$repo" in
	./*|../*)
		# dereference source url relative to parent's url
		realrepo=$(resolve_relative_url "$repo") || exit
		;;
	*:*|/*)
		# absolute url
		realrepo=$repo
		;;
	*)
		die "repo URL: '$repo' must be absolute or begin with ./|../"
	;;
	esac

193 194 195 196 197 198 199 200 201 202 203 204
	# normalize path:
	# multiple //; leading ./; /./; /../; trailing /
	path=$(printf '%s/\n' "$path" |
		sed -e '
			s|//*|/|g
			s|^\(\./\)*||
			s|/\./|/|g
			:start
			s|\([^/]*\)/\.\./||
			tstart
			s|/*$||
		')
205
	git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
206 207
	die "'$path' already exists in the index"

208 209 210 211 212 213 214 215
	if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
	then
		echo >&2 "The following path is ignored by one of your .gitignore files:" &&
		echo >&2 $path &&
		echo >&2 "Use -f if you really want to add it."
		exit 1
	fi

216 217 218
	# perhaps the path exists and is already a git repo, else clone it
	if test -e "$path"
	then
219
		if test -d "$path"/.git -o -f "$path"/.git
220 221 222 223 224
		then
			echo "Adding existing repo at '$path' to the index"
		else
			die "'$path' already exists and is not a valid git repo"
		fi
225 226 227 228 229 230 231 232 233 234

		case "$repo" in
		./*|../*)
			url=$(resolve_relative_url "$repo") || exit
		    ;;
		*)
			url="$repo"
			;;
		esac
		git config submodule."$path".url "$url"
235 236
	else

237
		module_clone "$path" "$realrepo" "$reference" || exit
238
		(
239
			clear_local_git_env
240 241 242 243 244 245 246
			cd "$path" &&
			# ash fails to wordsplit ${branch:+-b "$branch"...}
			case "$branch" in
			'') git checkout -f -q ;;
			?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
			esac
		) || die "Unable to checkout submodule '$path'"
247 248
	fi

249
	git add $force "$path" ||
250 251
	die "Failed to add submodule '$path'"

252 253
	git config -f .gitmodules submodule."$path".path "$path" &&
	git config -f .gitmodules submodule."$path".url "$repo" &&
254
	git add --force .gitmodules ||
255 256 257
	die "Failed to register submodule '$path'"
}

258 259 260 261 262 263 264 265
#
# Execute an arbitrary command sequence in each checked out
# submodule
#
# $@ = command to execute
#
cmd_foreach()
{
266 267 268 269 270 271 272
	# parse $args after "submodule ... foreach".
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
			GIT_QUIET=1
			;;
273 274 275
		--recursive)
			recursive=1
			;;
276 277 278 279 280 281 282 283 284 285
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

286 287
	toplevel=$(pwd)

288
	module_list |
289 290 291 292
	while read mode sha1 stage path
	do
		if test -e "$path"/.git
		then
293
			say "Entering '$prefix$path'"
294
			name=$(module_name "$path")
295 296
			(
				prefix="$prefix$path/"
297
				clear_local_git_env
298 299 300 301 302 303 304
				cd "$path" &&
				eval "$@" &&
				if test -n "$recursive"
				then
					cmd_foreach "--recursive" "$@"
				fi
			) ||
305 306 307 308 309
			die "Stopping at '$path'; script returned non-zero status."
		fi
	done
}

L
Lars Hjemli 已提交
310
#
311
# Register submodules in .git/config
L
Lars Hjemli 已提交
312 313 314
#
# $@ = requested paths (default to all)
#
315
cmd_init()
L
Lars Hjemli 已提交
316
{
317 318 319 320 321
	# parse $args after "submodule ... init".
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
322
			GIT_QUIET=1
323 324 325 326 327 328 329 330 331 332 333 334 335 336 337
			;;
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

338
	module_list "$@" |
L
Lars Hjemli 已提交
339 340
	while read mode sha1 stage path
	do
341
		# Skip already registered paths
342
		name=$(module_name "$path") || exit
343
		url=$(git config submodule."$name".url)
344
		test -z "$url" || continue
L
Lars Hjemli 已提交
345

346
		url=$(git config -f .gitmodules submodule."$name".url)
L
Lars Hjemli 已提交
347
		test -z "$url" &&
348
		die "No url found for submodule path '$path' in .gitmodules"
L
Lars Hjemli 已提交
349

350 351 352
		# Possibly a url relative to parent
		case "$url" in
		./*|../*)
353
			url=$(resolve_relative_url "$url") || exit
354 355 356
			;;
		esac

357
		git config submodule."$name".url "$url" ||
358
		die "Failed to register url for submodule path '$path'"
L
Lars Hjemli 已提交
359

360 361 362 363
		upd="$(git config -f .gitmodules submodule."$name".update)"
		test -z "$upd" ||
		git config submodule."$name".update "$upd" ||
		die "Failed to register update mode for submodule path '$path'"
364

365
		say "Submodule '$name' ($url) registered for path '$path'"
L
Lars Hjemli 已提交
366 367 368 369
	done
}

#
370
# Update each submodule path to correct revision, using clone and checkout as needed
L
Lars Hjemli 已提交
371 372 373
#
# $@ = requested paths (default to all)
#
374
cmd_update()
L
Lars Hjemli 已提交
375
{
376
	# parse $args after "submodule ... update".
377
	orig_args="$@"
378 379 380 381
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
382
			shift
383
			GIT_QUIET=1
384
			;;
385
		-i|--init)
386
			init=1
387 388
			shift
			;;
389 390 391 392
		-N|--no-fetch)
			shift
			nofetch=1
			;;
393 394
		-r|--rebase)
			shift
395
			update="rebase"
396
			;;
397 398 399 400 401 402 403 404 405
		--reference)
			case "$2" in '') usage ;; esac
			reference="--reference=$2"
			shift 2
			;;
		--reference=*)
			reference="$1"
			shift
			;;
406 407 408 409
		-m|--merge)
			shift
			update="merge"
			;;
410 411 412 413
		--recursive)
			shift
			recursive=1
			;;
414 415 416 417 418 419 420 421 422 423 424 425 426
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
	done

427 428 429 430 431
	if test -n "$init"
	then
		cmd_init "--" "$@" || return
	fi

432
	module_list "$@" |
L
Lars Hjemli 已提交
433 434
	while read mode sha1 stage path
	do
435
		name=$(module_name "$path") || exit
436
		url=$(git config submodule."$name".url)
437
		update_module=$(git config submodule."$name".update)
438
		if test -z "$url"
L
Lars Hjemli 已提交
439 440 441 442
		then
			# Only mention uninitialized submodules when its
			# path have been specified
			test "$#" != "0" &&
443
			say "Submodule path '$path' not initialized" &&
444
			say "Maybe you want to use 'update --init'?"
445 446 447
			continue
		fi

448
		if ! test -d "$path"/.git -o -f "$path"/.git
449
		then
450
			module_clone "$path" "$url" "$reference"|| exit
451 452
			subsha1=
		else
453
			subsha1=$(clear_local_git_env; cd "$path" &&
454
				git rev-parse --verify HEAD) ||
455
			die "Unable to find current revision in submodule path '$path'"
L
Lars Hjemli 已提交
456
		fi
457

458
		if ! test -z "$update"
459
		then
460
			update_module=$update
461 462
		fi

L
Lars Hjemli 已提交
463 464
		if test "$subsha1" != "$sha1"
		then
465 466 467 468 469
			force=
			if test -z "$subsha1"
			then
				force="-f"
			fi
470 471 472

			if test -z "$nofetch"
			then
473
				(clear_local_git_env; cd "$path" &&
474 475 476 477
					git-fetch) ||
				die "Unable to fetch in submodule path '$path'"
			fi

478 479 480
			case "$update_module" in
			rebase)
				command="git rebase"
481 482
				action="rebase"
				msg="rebased onto"
483
				;;
484 485 486 487 488
			merge)
				command="git merge"
				action="merge"
				msg="merged in"
				;;
489 490
			*)
				command="git checkout $force -q"
491 492
				action="checkout"
				msg="checked out"
493 494
				;;
			esac
L
Lars Hjemli 已提交
495

496
			(clear_local_git_env; cd "$path" && $command "$sha1") ||
497 498
			die "Unable to $action '$sha1' in submodule path '$path'"
			say "Submodule path '$path': $msg '$sha1'"
L
Lars Hjemli 已提交
499
		fi
500 501 502

		if test -n "$recursive"
		then
503
			(clear_local_git_env; cd "$path" && cmd_update $orig_args) ||
504 505
			die "Failed to recurse into submodule path '$path'"
		fi
L
Lars Hjemli 已提交
506 507 508
	done
}

509 510
set_name_rev () {
	revname=$( (
511
		clear_local_git_env
512
		cd "$1" && {
513 514
			git describe "$2" 2>/dev/null ||
			git describe --tags "$2" 2>/dev/null ||
515 516
			git describe --contains "$2" 2>/dev/null ||
			git describe --all --always "$2"
517 518 519 520
		}
	) )
	test -z "$revname" || revname=" ($revname)"
}
P
Ping Yin 已提交
521 522 523 524 525 526 527 528 529
#
# Show commit summary for submodules in index or working tree
#
# If '--cached' is given, show summary between index and given commit,
# or between working tree and given commit
#
# $@ = [commit (default 'HEAD'),] requested paths (default all)
#
cmd_summary() {
530
	summary_limit=-1
531
	for_status=
532
	diff_cmd=diff-index
533

P
Ping Yin 已提交
534 535 536 537 538 539 540
	# parse $args after "submodule ... summary".
	while test $# -ne 0
	do
		case "$1" in
		--cached)
			cached="$1"
			;;
541 542 543
		--files)
			files="$1"
			;;
544 545 546
		--for-status)
			for_status="$1"
			;;
547 548 549 550 551 552 553 554 555
		-n|--summary-limit)
			if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
			then
				:
			else
				usage
			fi
			shift
			;;
P
Ping Yin 已提交
556 557 558 559 560 561 562 563 564 565 566 567 568
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done
569

570 571
	test $summary_limit = 0 && return

572
	if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
P
Ping Yin 已提交
573 574
	then
		head=$rev
575
		test $# = 0 || shift
576 577
	elif test -z "$1" -o "$1" = "HEAD"
	then
578 579
		# before the first commit: compare with an empty tree
		head=$(git hash-object -w -t tree --stdin </dev/null)
580
		test -z "$1" || shift
P
Ping Yin 已提交
581
	else
582
		head="HEAD"
P
Ping Yin 已提交
583 584
	fi

585 586 587 588 589 590 591 592
	if [ -n "$files" ]
	then
		test -n "$cached" &&
		die "--cached cannot be used with --files"
		diff_cmd=diff-files
		head=
	fi

P
Ping Yin 已提交
593 594
	cd_to_toplevel
	# Get modified modules cared by user
595
	modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
596
		sane_egrep '^:([0-7]* )?160000' |
P
Ping Yin 已提交
597 598 599 600 601 602 603 604 605
		while read mod_src mod_dst sha1_src sha1_dst status name
		do
			# Always show modules deleted or type-changed (blob<->module)
			test $status = D -o $status = T && echo "$name" && continue
			# Also show added or modified modules which are checked out
			GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
			echo "$name"
		done
	)
606

607 608
	test -z "$modules" && return

609
	git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
610
	sane_egrep '^:([0-7]* )?160000' |
611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635
	cut -c2- |
	while read mod_src mod_dst sha1_src sha1_dst status name
	do
		if test -z "$cached" &&
			test $sha1_dst = 0000000000000000000000000000000000000000
		then
			case "$mod_dst" in
			160000)
				sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
				;;
			100644 | 100755 | 120000)
				sha1_dst=$(git hash-object $name)
				;;
			000000)
				;; # removed
			*)
				# unexpected type
				echo >&2 "unexpected mode $mod_dst"
				continue ;;
			esac
		fi
		missing_src=
		missing_dst=

		test $mod_src = 160000 &&
M
Miklos Vajna 已提交
636
		! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
637 638 639
		missing_src=t

		test $mod_dst = 160000 &&
M
Miklos Vajna 已提交
640
		! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
641
		missing_dst=t
642

643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666
		total_commits=
		case "$missing_src,$missing_dst" in
		t,)
			errmsg="  Warn: $name doesn't contain commit $sha1_src"
			;;
		,t)
			errmsg="  Warn: $name doesn't contain commit $sha1_dst"
			;;
		t,t)
			errmsg="  Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
			;;
		*)
			errmsg=
			total_commits=$(
			if test $mod_src = 160000 -a $mod_dst = 160000
			then
				range="$sha1_src...$sha1_dst"
			elif test $mod_src = 160000
			then
				range=$sha1_src
			else
				range=$sha1_dst
			fi
			GIT_DIR="$name/.git" \
J
Jeff King 已提交
667
			git rev-list --first-parent $range -- | wc -l
668
			)
669
			total_commits=" ($(($total_commits + 0)))"
670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693
			;;
		esac

		sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
		sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
		if test $status = T
		then
			if test $mod_dst = 160000
			then
				echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
			else
				echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
			fi
		else
			echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
		fi
		if test -n "$errmsg"
		then
			# Don't give error msg for modification whose dst is not submodule
			# i.e. deleted or changed to blob
			test $mod_dst = 160000 && echo "$errmsg"
		else
			if test $mod_src = 160000 -a $mod_dst = 160000
			then
694 695
				limit=
				test $summary_limit -gt 0 && limit="-$summary_limit"
696
				GIT_DIR="$name/.git" \
697
				git log $limit --pretty='format:  %m %s' \
698 699 700 701 702 703 704 705 706 707 708 709
				--first-parent $sha1_src...$sha1_dst
			elif test $mod_dst = 160000
			then
				GIT_DIR="$name/.git" \
				git log --pretty='format:  > %s' -1 $sha1_dst
			else
				GIT_DIR="$name/.git" \
				git log --pretty='format:  < %s' -1 $sha1_src
			fi
			echo
		fi
		echo
710 711
	done |
	if test -n "$for_status"; then
712 713 714 715 716
		if [ -n "$files" ]; then
			echo "# Submodules changed but not updated:"
		else
			echo "# Submodule changes to be committed:"
		fi
717 718 719 720 721
		echo "#"
		sed -e 's|^|# |' -e 's|^# $|#|'
	else
		cat
	fi
P
Ping Yin 已提交
722
}
L
Lars Hjemli 已提交
723
#
724
# List all submodules, prefixed with:
L
Lars Hjemli 已提交
725 726 727 728 729 730 731 732
#  - submodule not initialized
#  + different revision checked out
#
# If --cached was specified the revision in the index will be printed
# instead of the currently checked out revision.
#
# $@ = requested paths (default to all)
#
733
cmd_status()
L
Lars Hjemli 已提交
734
{
735
	# parse $args after "submodule ... status".
736
	orig_args="$@"
737 738 739 740
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
741
			GIT_QUIET=1
742 743 744 745
			;;
		--cached)
			cached=1
			;;
746 747 748
		--recursive)
			recursive=1
			;;
749 750 751 752 753 754 755 756 757 758 759 760 761 762
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
		shift
	done

763
	module_list "$@" |
L
Lars Hjemli 已提交
764 765
	while read mode sha1 stage path
	do
766
		name=$(module_name "$path") || exit
767
		url=$(git config submodule."$name".url)
768
		displaypath="$prefix$path"
769
		if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
L
Lars Hjemli 已提交
770
		then
771
			say "-$sha1 $displaypath"
L
Lars Hjemli 已提交
772 773
			continue;
		fi
774
		set_name_rev "$path" "$sha1"
775
		if git diff-files --ignore-submodules=dirty --quiet -- "$path"
L
Lars Hjemli 已提交
776
		then
777
			say " $sha1 $displaypath$revname"
L
Lars Hjemli 已提交
778 779 780
		else
			if test -z "$cached"
			then
781
				sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
782
				set_name_rev "$path" "$sha1"
L
Lars Hjemli 已提交
783
			fi
784 785 786 787 788 789 790
			say "+$sha1 $displaypath$revname"
		fi

		if test -n "$recursive"
		then
			(
				prefix="$displaypath/"
791
				clear_local_git_env
792 793 794 795
				cd "$path" &&
				cmd_status $orig_args
			) ||
			die "Failed to recurse into submodule path '$path'"
L
Lars Hjemli 已提交
796 797 798
		fi
	done
}
799 800 801 802 803 804 805 806 807 808 809
#
# Sync remote urls for submodules
# This makes the value for remote.$remote.url match the value
# specified in .gitmodules.
#
cmd_sync()
{
	while test $# -ne 0
	do
		case "$1" in
		-q|--quiet)
810
			GIT_QUIET=1
811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830
			shift
			;;
		--)
			shift
			break
			;;
		-*)
			usage
			;;
		*)
			break
			;;
		esac
	done
	cd_to_toplevel
	module_list "$@" |
	while read mode sha1 stage path
	do
		name=$(module_name "$path")
		url=$(git config -f .gitmodules --get submodule."$name".url)
831 832 833 834 835 836 837 838

		# Possibly a url relative to parent
		case "$url" in
		./*|../*)
			url=$(resolve_relative_url "$url") || exit
			;;
		esac

839
		if git config "submodule.$name.url" >/dev/null 2>/dev/null
840
		then
841 842 843 844 845 846 847 848 849 850 851 852
			say "Synchronizing submodule url for '$name'"
			git config submodule."$name".url "$url"

			if test -e "$path"/.git
			then
			(
				clear_local_git_env
				cd "$path"
				remote=$(get_default_remote)
				git config remote."$remote".url "$url"
			)
			fi
853 854 855
		fi
	done
}
L
Lars Hjemli 已提交
856

857 858 859 860 861 862 863
# This loop parses the command line arguments to find the
# subcommand name to dispatch.  Parsing of the subcommand specific
# options are primarily done by the subcommand implementations.
# Subcommand specific options such as --branch and --cached are
# parsed here as well, for backward compatibility.

while test $# != 0 && test -z "$command"
L
Lars Hjemli 已提交
864 865
do
	case "$1" in
866
	add | foreach | init | update | status | summary | sync)
867
		command=$1
L
Lars Hjemli 已提交
868 869
		;;
	-q|--quiet)
870
		GIT_QUIET=1
L
Lars Hjemli 已提交
871
		;;
872 873 874 875 876 877 878 879
	-b|--branch)
		case "$2" in
		'')
			usage
			;;
		esac
		branch="$2"; shift
		;;
L
Lars Hjemli 已提交
880
	--cached)
P
Ping Yin 已提交
881
		cached="$1"
L
Lars Hjemli 已提交
882 883 884 885 886 887 888 889 890 891 892 893 894 895
		;;
	--)
		break
		;;
	-*)
		usage
		;;
	*)
		break
		;;
	esac
	shift
done

896 897 898 899 900 901
# No command word defaults to "status"
test -n "$command" || command=status

# "-b branch" is accepted only by "add"
if test -n "$branch" && test "$command" != add
then
902
	usage
903 904
fi

P
Ping Yin 已提交
905 906
# "--cached" is accepted only by "status" and "summary"
if test -n "$cached" && test "$command" != status -a "$command" != summary
907
then
L
Lars Hjemli 已提交
908
	usage
909 910 911
fi

"cmd_$command" "$@"